unit hiDateConvertor; {  - ver 2.00 }

interface

uses Windows,Kol,Share,Debug;

type
 THIDateConvertor = class(TDebug)
   private
      FResult:TData;
      ST:TSystemTime;
      DateTime:TDateTime;
      FDateTime:string;
      procedure HeapIntToXXXX(d:PData);
   public
     _prop_Mode:byte;
     _prop_Format:string;

     _data_DYear:THI_Event;
     _data_DMonth:THI_Event;
     _data_DDay:THI_Event;
     _data_DHour:THI_Event;
     _data_DMinute:THI_Event;
     _data_DSecond:THI_Event;
     _data_DMilliseconds:THI_Event;

     _data_Data:THI_Event;
     _event_OnResult:THI_Event;

     procedure _work_doConvert0  (var _Data:TData; Index:word);//DateRealToHeapInt
     procedure _work_doConvert1  (var _Data:TData; Index:word);//HeapIntToDateReal
     procedure _work_doConvert2  (var _Data:TData; Index:word);//DateVCLHeapInt
     procedure _work_doConvert3  (var _Data:TData; Index:word);//HeapIntToDateVCL
     procedure _work_doConvert4  (var _Data:TData; Index:word);//StrFmtToHeapInt
     procedure _work_doConvert5  (var _Data:TData; Index:word);//HeapIntToStrFmt
     procedure _work_doConvert6  (var _Data:TData; Index:word);//DateRealToDateVCL
     procedure _work_doConvert7  (var _Data:TData; Index:word);//DateVCLToDateReal
     procedure _work_doConvert8  (var _Data:TData; Index:word);//StrFmtToDateReal
     procedure _work_doConvert9  (var _Data:TData; Index:word);//DateRealToStrFmt
     procedure _work_doConvert10 (var _Data:TData; Index:word);//StrFmtToDateVCL
     procedure _work_doConvert11 (var _Data:TData; Index:word);//DateVCLToStrFmt

     procedure _var_LeapYear     (var _Data:TData; Index:word);
     procedure _var_DayOfWeek    (var _Data:TData; Index:word);
     procedure _var_Year         (var _Data:TData; Index:word);
     procedure _var_Month        (var _Data:TData; Index:word);
     procedure _var_Day          (var _Data:TData; Index:word);
     procedure _var_Hour         (var _Data:TData; Index:word);
     procedure _var_Minute       (var _Data:TData; Index:word);
     procedure _var_Second       (var _Data:TData; Index:word);
     procedure _var_Milliseconds (var _Data:TData; Index:word);
     procedure _var_Result       (var _Data:TData; Index:word);

end;

implementation

procedure THIDateConvertor.HeapIntToXXXX;
begin
   FillChar(ST, Sizeof(ST), 0);
   ST.wYear:=         ReadInteger(d^, _data_DYear, 0);
   ST.wMonth:=        ReadInteger(d^, _data_DMonth, 0);
   ST.wDay:=          ReadInteger(d^, _data_DDay, 0);
   ST.wHour:=         ReadInteger(d^, _data_DHour, 0);
   ST.wMinute:=       ReadInteger(d^, _data_DMinute, 0);
   ST.wSecond:=       ReadInteger(d^, _data_DSecond, 0);
   ST.wMilliseconds:= ReadInteger(d^, _data_DMilliseconds, 0); 
   SystemTime2DateTime(ST, DateTime);
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
end;

procedure THIDateConvertor._work_doConvert0;//DateRealToHeapInt
begin
   DateTime:= ReadReal(_Data,_data_Data,0);
   FillChar(ST, Sizeof(ST), 0);
   DateTime2SystemTime(DateTime, ST);
   dtNull(FResult);
   _hi_CreateEvent(_Data,@_event_onResult, FResult); 
end;

procedure THIDateConvertor._work_doConvert1;//HeapIntToDateReal
var   dt:TData;
begin
   dt:= ReadMTData(_Data,_data_Data);
   CopyData(@dt,@dt);
   HeapIntToXXXX(@dt);
   dtReal(FResult,DateTime);
   _hi_CreateEvent(_Data,@_event_onResult, FResult); 
end;

procedure THIDateConvertor._work_doConvert2;//DateVCLHeapInt
begin
   DateTime:= ReadReal(_Data,_data_Data,0) + VCLDATE0;
   FillChar(ST, Sizeof(ST), 0);
   DateTime2SystemTime(DateTime, ST);
   dtNull(FResult);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);
end;

procedure THIDateConvertor._work_doConvert3;//HeapIntToDateVCL
var   dt:TData;
begin
   CopyData(@dt,@_Data);
   HeapIntToXXXX(@dt);
   dtReal(FResult,DateTime - VCLDATE0);
   _hi_CreateEvent(_Data,@_event_onResult, FResult); 
end;

procedure THIDateConvertor._work_doConvert4;//StrFmtToHeapInt
begin
   FDateTime:= ReadString(_Data,_data_Data,'');
   DateTime:= Str2DateTimeFmt(_prop_Format, FDateTime);
   FillChar(ST, Sizeof(ST), 0);
   DateTime2SystemTime(DateTime, ST);
   dtNull(FResult);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);  
end;

procedure THIDateConvertor._work_doConvert5;//HeapIntToStrFmt
var   dt:TData;
begin
   CopyData(@dt,@_Data);
   HeapIntToXXXX(@dt);
   dtString(FResult,Time2StrFmt(Date2StrFmt(_prop_Format, DateTime), DateTime));
   _hi_CreateEvent(_Data,@_event_onResult, FResult); 
end;

procedure THIDateConvertor._work_doConvert6;//DateRealToDateVCL
begin
   dtReal(FResult, ReadReal(_Data,_data_Data,0) - VCLDATE0);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);   
end;

procedure THIDateConvertor._work_doConvert7;//DateVCLToDateReal
begin
   dtReal(FResult, ReadReal(_Data,_data_Data,0) + VCLDATE0);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);  
end;

procedure THIDateConvertor._work_doConvert8;//StrFmtToDateReal
begin
   FDateTime:= ReadString(_Data,_data_Data,'');
   DateTime:= Str2DateTimeFmt(_prop_Format, FDateTime);
   dtReal(FResult,DateTime);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);   
end;

procedure THIDateConvertor._work_doConvert9;//DateRealToStrFmt
begin
   DateTime:= ReadReal(_Data,_data_Data,0);
   dtString(FResult,Time2StrFmt(Date2StrFmt(_prop_Format, DateTime), DateTime));
   _hi_CreateEvent(_Data,@_event_onResult, FResult);
end;

procedure THIDateConvertor._work_doConvert10;//StrFmtToDateVCL
begin
   FDateTime:= ReadString(_Data,_data_Data,'');
   DateTime:= Str2DateTimeFmt(_prop_Format, FDateTime) - VCLDATE0;;
   dtReal(FResult,DateTime);
   _hi_CreateEvent(_Data,@_event_onResult, FResult);   
end;

procedure THIDateConvertor._work_doConvert11;//DateVCLToStrFmt
begin
   DateTime:= ReadReal(_Data,_data_Data,0);
   DateTime:= DateTime + VCLDATE0;
   dtString(FResult,Time2StrFmt(Date2StrFmt(_prop_Format, DateTime), DateTime));
   _hi_CreateEvent(_Data,@_event_onResult, FResult); 
end;

procedure THIDateConvertor._var_Result;
begin
   CopyData(@_Data,@FResult); 
end;

procedure THIDateConvertor._var_LeapYear;
begin
   if IsLeapYear(ST.wYear) then
      dtInteger(_Data, 1)
   else
      dtInteger(_Data, 0);
end;

procedure THIDateConvertor._var_DayOfWeek;    begin dtInteger(_Data,DayOfWeek(DateTime)); end;
procedure THIDateConvertor._var_Year;         begin dtInteger(_Data,ST.wYear); end;
procedure THIDateConvertor._var_Month;        begin dtInteger(_Data,ST.wMonth); end;
procedure THIDateConvertor._var_Day;          begin dtInteger(_Data,ST.wDay); end;
procedure THIDateConvertor._var_Hour;         begin dtInteger(_Data,ST.wHour); end;
procedure THIDateConvertor._var_Minute;       begin dtInteger(_Data,ST.wMinute); end;
procedure THIDateConvertor._var_Second;       begin dtInteger(_Data,ST.wSecond); end;
procedure THIDateConvertor._var_Milliseconds; begin dtInteger(_Data,ST.wMilliseconds); end;

end.
