unit hiFileAttributes; {   ver 2.00}

interface

uses Windows,Kol,Share,Debug;

type
  THIFileAttributes = class(TDebug)
   private
    fn:string;
    sys:WIN32_FILE_ATTRIBUTE_DATA;
    procedure GetTimeV(var _Data:TData; t:PFileTime);
   public
    _prop_FileName:string;
    _prop_Attr:integer;
//    _prop_Format:string;
    _prop_TimeType:byte;

    _data_Attr:THI_Event;
    _data_FileName:THI_Event;
    _event_onRead:THI_Event;
    _event_onError:THI_Event;

    procedure _work_doRead(var _Data:TData; Index:word);
    procedure _work_doSet(var _Data:TData; Index:word);
    procedure _var_DateCreate(var _Data:TData; Index:word);
    procedure _var_DateAccess(var _Data:TData; Index:word);
    procedure _var_DateModify(var _Data:TData; Index:word);
    procedure _var_FileSize(var _Data:TData; Index:word);
  end;

implementation

uses HiTime;

const At:array[0..8] of DWORD = (
  FILE_ATTRIBUTE_NORMAL,
  FILE_ATTRIBUTE_ARCHIVE,
  FILE_ATTRIBUTE_READONLY,
  FILE_ATTRIBUTE_HIDDEN,
  FILE_ATTRIBUTE_SYSTEM,
  FILE_ATTRIBUTE_DIRECTORY,
  FILE_ATTRIBUTE_TEMPORARY,
  FILE_ATTRIBUTE_COMPRESSED,
  FILE_ATTRIBUTE_OFFLINE{,
  FILE_ATTRIBUTE_ENCRYPTED,
  FILE_ATTRIBUTE_REPARSE_POINT,
  FILE_ATTRIBUTE_SPARSE_FILE,
  FILE_ATTRIBUTE_NOT_CONTENT_INDEXED});

procedure THIFileAttributes._work_doRead;
var i,j:integer;
begin
  fn := readString(_Data,_data_FileName,_prop_FileName);
  if not GetFileAttributesEx(PChar(fn),GetFileExInfoStandard,@sys) then begin
    fn := '';
    _hi_CreateEvent(_Data,@_event_onError);
    exit;
  end;
  i := 0;
  for j := 0 to high(At) do
    i := i or ((integer((sys.dwFileAttributes and At[j])<>0)) shl j);
  _hi_CreateEvent(_Data,@_event_onRead,i);
end;

procedure THIFileAttributes._work_doSet;
var i,j,Attr:dword;
    fn:string;
begin
  fn := readString(_Data,_data_FileName,_prop_FileName);
  i := ReadInteger(_Data,_data_Attr,_prop_Attr);
  Attr := 0;
  for j := 0 to high(At) do
   Attr := Attr or ((i shr j) and 1)*At[j];

  if not SetFileAttributes(PChar(fn),Attr )then
    _hi_CreateEvent(_Data,@_event_onError);
end;

procedure THIFileAttributes.GetTimeV;
var m:TFileTime;
    sys:TSystemTime;
    DateTime:TDateTime;
begin
  if fn = '' then begin
    fn := readString(_Data,_data_FileName,_prop_FileName);
    if not GetFileAttributesEx(PChar(fn),GetFileExInfoStandard,@sys) then
      fn := '';
  end;
  if fn <> '' then begin
    if _prop_TimeType=1 then FileTimeToLocalFileTime(t^,m)
    else m := t^;
    FileTimeToSystemTime(m,sys);
    SystemTime2DateTime(sys, DateTime);
    dtReal(_Data,DateTime);
  end else dtNull(_data);
end;

procedure THIFileAttributes._var_FileSize;
type T=record L,H:dword end;
var Sz:int64;
begin
  if fn = '' then begin
    fn := readString(_Data,_data_FileName,_prop_FileName);
    if not GetFileAttributesEx(PChar(fn),GetFileExInfoStandard,@sys) then
      fn := '';
  end;
  if fn <> '' then
    if (sys.nFileSizeHigh=0)and(integer(sys.nFileSizeLow)>=0) then
      dtInteger(_Data,sys.nFileSizeLow)
    else begin
      T(Sz).L := sys.nFileSizeLow;
      T(Sz).H := sys.nFileSizeHigh;
      dtReal(_Data,Sz);
    end
  else dtNull(_data);
end;

procedure THIFileAttributes._var_DateCreate;
begin
  GetTimeV(_Data,@sys.ftCreationTime);
end;

procedure THIFileAttributes._var_DateAccess;
begin
  GetTimeV(_Data,@sys.ftLastAccessTime);
end;

procedure THIFileAttributes._var_DateModify;
begin
  GetTimeV(_Data,@sys.ftLastWriteTime);
end;

end.
